#import "StringEx.h"

//StringExの実装
@implementation StringEx

//色の指定(2)
- (void)setColor_r:(int)r g:(int)g b:(int)b {
    [[UIColor colorWithRed:r/255.0f green:g/255.0f 
        blue: b/255.0f alpha:1.0f] set];
}

//文字列の描画(4)
- (void)drawString:(NSString*)string 
    x:(float)x y:(float)y font:(UIFont*)font {
    [string drawAtPoint:CGPointMake(x,y) withFont:font];
}

//初期化
- (id)initWithFrame:(CGRect)frame {
    self=[super initWithFrame:frame];
    if (self) {
        self.backgroundColor=[UIColor whiteColor];
    }
    return self;
}

//描画
- (void)drawRect:(CGRect)rect {
    //フォントの生成(1)
    UIFont* font=[UIFont systemFontOfSize:24];

    //文字色の指定(2)
    [self setColor_r:0 g:0 b:0];
    
    //文字列の描画(3)(4)
    [self drawString:[NSString stringWithFormat:@"画面サイズ:%dx%d",
        (int)self.frame.size.width,
        (int)self.frame.size.height] x:0 y:0 font:font];

    //文字幅の取得(5)
    CGSize size=[@"A" sizeWithFont:font];
    [self drawString:[NSString stringWithFormat:@"文字幅:%d",
        (int)size.width] x:0 y:30 font:font]; 
       
    //12ドットの文字列の描画
    font=[UIFont systemFontOfSize:12];
    [self setColor_r:255 g:0 b:0];
    [self drawString:@"12dot" x:0 y:30*2 font:font]; 

     //16ドットの文字列の描画
    font=[UIFont systemFontOfSize:16];
    [self setColor_r:0 g:255 b:0];
    [self drawString:@"16dot" x:0 y:30*3 font:font]; 

    //24ドットの文字列の描画
    font=[UIFont systemFontOfSize:24];
    [self setColor_r:0 g:0 b:255];
    [self drawString:@"24dot" x:0 y:30*4 font:font]; 
}
@end
