#include "TimerEx.h"

//TimerExの実装
@implementation TimerEx

//初期化
- (id)initWithFrame:(CGRect)frame {
    self=[super initWithFrame:frame];
    if (self) {
        self.backgroundColor=[UIColor whiteColor];
 
        //画像の読み込み
        _image=[[UIImage imageNamed:@"sample.png"] retain];

        //変数の初期化
        _px=self.bounds.size.width/2;
        _py=self.bounds.size.height/2;
        _vx=4.0f;
        _vy=4.0f;
        _timer=nil;        
    }
    return self;
}

//メモリ解放
- (void)dealloc {
    //タイマー動いたままではdeallocは呼ばれない(3)
    [_image release];
    [super dealloc]; 
}

//描画
- (void)drawRect:(CGRect)rect {
    //イメージの描画
    [_image drawAtPoint:(CGPointMake(
        _px-_image.size.width/2,_py-_image.size.height/2))];
}

//タッチ終了イベントの処理
- (void)touchesEnded:(NSSet*)touches withEvent:(UIEvent*)event {
    if (_timer==nil) {
        //タイマーの生成(1)        
        _timer=[NSTimer scheduledTimerWithTimeInterval:1.0f/30.0f
            target:self
            selector:@selector(onTick:)
            userInfo:nil
            repeats:YES];//retain必要なし
    } else {
        //タイマーの停止(2)
        [_timer invalidate];
        _timer=nil;//release必要なし
    }
}

//定期処理(4)
- (void)onTick:(NSTimer*)timer {
    //移動
    _px+=_vx;//X座標
    _py+=_vy;//Y座標
    if (_px<0.0f || self.frame.size.width <_px) _vx=-_vx;//X反転
    if (_py<0.0f || self.frame.size.height<_py) _vy=-_vy;//Y反転
    
    //再描画
    [self setNeedsDisplay];
}
@end
