#import "SliderEx.h"

#define BTN_SHOW 0

//SliderExの実装
@implementation SliderEx

//アラートの表示
- (void)showAlert:(NSString*)title text:(NSString*)text {
    UIAlertView* alert=[[[UIAlertView alloc] 
        initWithTitle:title message:text delegate:nil 
        cancelButtonTitle:@"OK" otherButtonTitles:nil] autorelease];
    [alert show];
}

//テキストボタンの生成
- (UIButton*)makeButton:(CGRect)rect text:(NSString*)text tag:(int)tag {
    UIButton* button=[UIButton buttonWithType:UIButtonTypeRoundedRect];
    [button setFrame:rect];
    [button setTitle:text forState:UIControlStateNormal];
    [button setTag:tag];
    [button addTarget:self action:@selector(clickButton:) 
        forControlEvents:UIControlEventTouchUpInside];
    return button; 
}

//初期化
- (void)viewDidLoad {
    [super viewDidLoad];
        
    //スライダーの生成(1)
    _slider=[[UISlider alloc] init];
    [_slider setFrame:CGRectMake(0,0,300,32)];
    [_slider setMinimumValue:0];
    [_slider setMaximumValue:100];
    [_slider setValue:50];
    [self.view addSubview:_slider];
        
    //スイッチの生成(2)
    _switch=[[UISwitch alloc] init];
    [_switch setFrame:CGRectMake(0,50,200,32)];
    [_switch setOn:YES];
    [self.view addSubview:_switch];

    //表示ボタンの生成
    UIButton* btnShow=[self makeButton:CGRectMake(0,100,90,40) 
        text:@"表示" tag:BTN_SHOW];
    [self.view addSubview:btnShow];
}

//メモリ解放
- (void)dealloc {
    [_slider release];
    [_switch release];
    [super dealloc];
}

//ボタンクリック時のイベント処理
- (IBAction)clickButton:(UIButton*)sender {
    if (sender.tag==BTN_SHOW) {
        NSString* switchON=(_switch.on)?@"ON":@"OFF";
        [self showAlert:@"" text:[NSString stringWithFormat:
            @"スライダーの値=%d\nスイッチの値=%@",(int)_slider.value,switchON]];
    }
}

//画面を端末の向きにあわせて回転
- (BOOL)shouldAutorotateToInterfaceOrientation:
    (UIInterfaceOrientation)orientation {
    return YES;
}
@end
