#import <UIKit/UIKit.h>

//Graphicsの宣言(4)
@interface Graphics : NSObject {
    CGContextRef   _context;   //コンテキスト
    unsigned char* _contextBMP;//コンテキストBMP
	UIFont*        _font;      //フォント
}

//コンテキスト
- (void)setContext:(CGContextRef)context;
- (void)makeContext:(CGSize)size;
- (void)releaseContext;

//描画設定
- (void)setColorR:(float)r g:(float)g b:(float)b a:(float)a;
- (void)setColorR:(float)r g:(float)g b:(float)b;
- (void)setFont:(UIFont*)font;
- (void)setLineWidth:(float)lineWidth;
- (int)stringWidth:(NSString*)str;
- (void)setScaleW:(float)scaleW h:(float)scaleH;

//描画
- (void)drawLineX0:(float)x0 y0:(float)y0 x1:(float)x1 y1:(float)y1;
- (void)drawRectX:(float)x y:(float)y w:(float)w h:(float)h;
- (void)fillRectX:(float)x y:(float)y w:(float)w h:(float)h;
- (void)drawImage:(UIImage*)image x:(float)x y:(float)y;
- (void)drawImage:(UIImage*)image x:(float)x y:(float)y w:(float)w h:(float)h;
- (void)drawString:(NSString*)string x:(float)x y:(float)y;
@end