#import <UIKit/UIKit.h>
#import "Graphics.h"

//シーン定数(1)
#define S_START     0 //スタート
#define S_MAP       1 //マップ
#define S_APPEAR    2 //出現
#define S_COMMAND   3 //コマンド
#define S_ATTACK0   4 //攻撃0
#define S_ATTACK1   5 //攻撃1
#define S_DEFENCE0  6 //防御0
#define S_DEFENCE1  7 //防御1
#define S_ESCAPE0   8 //逃走0
#define S_ESCAPE1   9 //逃走1
#define S_WIN      10 //勝利
#define S_GAMEOVER 11 //ゲームオーバー
#define S_LEVELUP  12 //レベルアップ
#define S_ENDING   13 //エンディング

//キー定数
#define KEY_NONE   -1
#define KEY_LEFT   0
#define KEY_RIGHT  1
#define KEY_UP     2
#define KEY_DOWN   3
#define KEY_1      4
#define KEY_2      5
#define KEY_SELECT 6

//RPGViewの宣言
@interface RPGView : UIView {
    //マップ定数(2)
    int MAP[10][10];

    //勇者定数(3)
    int YU_MAXHP[4];   //最大体力
    int YU_ATTACK[4];  //攻撃力
    int YU_DEFENCE[4]; //守備力
    int YU_EXP[4];     //必要経験値
    
    //敵定数(4)
    NSMutableArray* EN_NAME;       //名前
    int             EN_MAXHP[4];   //最大体力
    int             EN_ATTACK[4];  //攻撃力
    int             EN_DEFENCE[4]; //守備力
    int             EN_EXP[4];     //取得経験値
    
    //サイズ定数
    int WIDTH;  //幅
    int HEIGHT; //高さ
    int SCALE;  //スケール

    //システム
    int             _init;  //初期化(1)
    int             _scene; //シーン(1)
    int             _key;   //キー
    int             _tick;  //時間経過
    int             _damage;//ダメージ
    Graphics*       _g;     //グラフィックス
    NSMutableArray* _bmp;   //ビットマップ
    
    //勇者パラメータ(3)
    int _yuX;   //X座標
    int _yuY;   //Y座標
    int _yuLV;  //レベル
    int _yuHP;  //体力
    int _yuEXP; //経験値
    
    //敵パラメータ(4)
    int _enType; //種類
    int _enHP;   //体力    
}
@end