#import "RPGView.h"

//RPGViewの実装
@implementation RPGView

//乱数の取得
- (int)rand:(int)num {
    return abs(arc4random())%num;
}

//コーダーの初期化
- (id)initWithCoder:(NSCoder*)coder {
    self=[super initWithCoder:coder];
    if (self) {
        //マップ定数
        int map[10][10]={
            {3,3,3,3,3,3,3,3,3,3},
            {3,1,0,0,0,0,3,0,0,3},
            {3,0,0,0,0,0,3,3,0,3},
            {3,0,3,3,3,3,3,3,0,3},
            {3,0,0,3,0,0,0,3,0,3},
            {3,3,0,3,0,3,3,3,0,3},
            {3,0,0,3,0,0,0,0,0,3},
            {3,0,3,3,0,3,0,3,3,3},
            {3,0,0,0,0,3,0,0,2,3},
            {3,3,3,3,3,3,3,3,3,3}};    
        for (int j=0;j<10;j++) {
            for (int i=0;i<10;i++) MAP[j][i]=map[j][i];
        }
        
        //勇者定数
        int yu_maxhp[4]={0,30,50,70};
        for (int i=0;i<4;i++) YU_MAXHP[i]=yu_maxhp[i];
        int yu_attack[4]={0,5,10,30};
        for (int i=0;i<4;i++) YU_ATTACK[i]=yu_attack[i];
        int yu_defence[4]={0,0,5,10};
        for (int i=0;i<4;i++) YU_DEFENCE[i]=yu_defence[i];
        int yu_exp[4]={0,0,3,6};
        for (int i=0;i<4;i++) YU_EXP[i]=yu_exp[i];
        
        //敵定数
        EN_NAME=[[NSMutableArray array] retain];
        [EN_NAME addObject:@"スラスラ"];
        [EN_NAME addObject:@"グリドラ"];
        int en_maxhp[2]={10,50};
        for (int i=0;i<2;i++) EN_MAXHP[i]=en_maxhp[i];
        int en_attack[2]={10,26};
        for (int i=0;i<2;i++) EN_ATTACK[i]=en_attack[i];
        int en_defence[2]={0,16};
        for (int i=0;i<2;i++) EN_DEFENCE[i]=en_defence[i];
        int en_exp[2]={1,99};
        for (int i=0;i<2;i++) EN_EXP[i]=en_exp[i];

        //サイズ定数
        CGRect bounds=[[UIScreen mainScreen] bounds];
        if (bounds.size.width<bounds.size.height) {
            WIDTH =bounds.size.height;
            HEIGHT=bounds.size.width;
        } else {
            WIDTH =bounds.size.width;
            HEIGHT=bounds.size.height;
        }
        SCALE=1;
        if (WIDTH>640) {
            SCALE=2;
            WIDTH/=2;
            HEIGHT/=2;
        }
        
        //システム
        _g=[[Graphics alloc] init];
        _bmp=[[NSMutableArray array] retain];
        for (int i=0;i<7;i++) {
            [_bmp addObject:[UIImage imageNamed:
                [NSString stringWithFormat:@"rpg%d.png",i]]];
        }
        
        //タイマーの開始
        _init=S_START;
        [NSTimer scheduledTimerWithTimeInterval:0.1f
            target:self selector:@selector(onTick:)
            userInfo:nil repeats:YES];        
    }
    return self;
}

//メモリ解放
- (void)dealloc {
    [EN_NAME release];
    [_g release];
    [_bmp release];
    [super dealloc];
}

//ステータスの描画
- (void)drawStatus {
    [_g setColorR:255 g:255 b:255];
    [_g fillRectX:(WIDTH-504)/2 y:8 w:504 h:54];
    if (_yuHP!=0) {
        [_g setColorR:0 g:0 b:0];
    } else {
        [_g setColorR:255 g:0 b:0];
    }
    [_g fillRectX:(WIDTH-500)/2 y:10 w:500 h:50];
    [_g setColorR:255 g:255 b:255];
    [_g setFont:[UIFont systemFontOfSize:32]];
    [_g drawString:[NSString stringWithFormat:@"勇者 LV%d HP%d/%d",
        _yuLV,_yuHP,YU_MAXHP[_yuLV]] x:(WIDTH-500)/2+50 y:16];
}

//戦闘画面の描画
- (void)drawBattle:(NSString*)message visible:(BOOL)visible {
    if (_yuHP!=0) {
        [_g setColorR:0 g:0 b:0];
    } else {
        [_g setColorR:255 g:0 b:0];
    }
    [_g fillRectX:0 y:0 w:WIDTH h:HEIGHT];
    [self drawStatus];
    if (visible) {
        UIImage* bmp=[_bmp objectAtIndex:5+_enType]; 
        [_g drawImage:bmp 
            x:(WIDTH-bmp.size.width)/2 
            y:HEIGHT-100-bmp.size.height];
    }
    [_g setColorR:255 g:255 b:255];
    [_g fillRectX:(WIDTH-504)/2 y:HEIGHT-122 w:504 h:104];
    if (_yuHP!=0) {
        [_g setColorR:0 g:0 b:0];
    } else {
        [_g setColorR:255 g:0 b:0];
    }
    [_g fillRectX:(WIDTH-500)/2 y:HEIGHT-120 w:500 h:100];
    [_g setColorR:255 g:255 b:255];
    [_g setFont:[UIFont systemFontOfSize:32]];
    [_g drawString:message x:(WIDTH-500)/2+50 y:HEIGHT-90];
}

//戦闘画面の描画
- (void)drawBattle:(NSString*)message {
    [self drawBattle:message visible:_enHP>=0];
}
         
//描画
- (void)drawRect:(CGRect)rect {
    BOOL flag=NO;
    
    //コンテキストの指定
    [_g setContext:UIGraphicsGetCurrentContext()];
    [_g setScaleW:SCALE h:SCALE];
    
    //バッファのクリア
    [_g setColorR:0 g:0 b:0];
    [_g fillRectX:0 y:0 w:WIDTH h:HEIGHT];
    
    //シーンの初期化
    if (_init>=0) {
        _scene=_init;
        //スタート
        if (_scene==S_START) {
            _scene=S_MAP;
            _yuX  =1; //X座標
            _yuY  =2; //Y座標
            _yuLV =1; //レベル
            _yuHP =30;//体力
            _yuEXP=1000; //経験値   
        }
        //攻撃1
        if (_scene==S_ATTACK1) {
            //ダメージの計算(6)
            _damage=YU_ATTACK[_yuLV]-EN_DEFENCE[_enType]+[self rand:10];
            if (_damage<= 1) _damage= 1;
            if (_damage>=99) _damage=99;
        }
        //防御1
        if (_scene==S_DEFENCE1) {
            //防御の計算(7)
            _damage=EN_ATTACK[_enType]-YU_DEFENCE[_yuLV]+[self rand:10];
            if (_damage<= 1) _damage= 1;
            if (_damage>=99) _damage=99;
        }        
        _init=-1;
        _tick=0;
        _key =KEY_NONE;
    }    
    
    //マップ
    if (_scene==S_MAP) {
        //移動
        if (_key==KEY_UP) {
            if (MAP[_yuY-1][_yuX]<=2) {_yuY--;flag=YES;}
        } else if (_key==KEY_DOWN) {
            if (MAP[_yuY+1][_yuX]<=2) {_yuY++;flag=YES;}
        } else if (_key==KEY_LEFT) {
            if (MAP[_yuY][_yuX-1]<=2) {_yuX--;flag=YES;}
        } else if (_key==KEY_RIGHT) {
            if (MAP[_yuY][_yuX+1]<=2) {_yuX++;flag=YES;}
        }
        
        //敵出現の計算(5)
        if (flag) {
            if (MAP[_yuY][_yuX]==0 && [self rand:10]==0) {
                _enType=0;_init=S_APPEAR;}
            if (MAP[_yuY][_yuX]==1) _yuHP=YU_MAXHP[_yuLV];
            if (MAP[_yuY][_yuX]==2) {_enType=1;_init=S_APPEAR;}
        }
        
        //描画
        for (int j=-3;j<=3;j++) {
            for (int i=-5;i<=5;i++) {
                int idx=3;
                if (0<=_yuX+i && _yuX+i<10 &&
                    0<=_yuY+j && _yuY+j<10) {
                    idx=MAP[_yuY+j][_yuX+i];
                }
                [_g drawImage:[_bmp objectAtIndex:idx] 
                    x:WIDTH/2-40+80*i y:HEIGHT/2-40+80*j];
            }
        }
        [_g drawImage:[_bmp objectAtIndex:4] 
            x:WIDTH/2-40 y:HEIGHT/2-40];
        [self drawStatus];
    }
    //出現
    else if (_scene==S_APPEAR) {
        _enHP=EN_MAXHP[_enType];
        
        //フラッシュ
        if (_tick<6) {
            if (_tick%2==0) {
                [_g setColorR:0 g:0 b:0];
            } else {
                [_g setColorR:255 g:255 b:255];
            }
            [_g fillRectX:0 y:0 w:WIDTH h:HEIGHT];
        }
        //選択
        else {
            [self drawBattle:[NSString stringWithFormat:
                @"%@があらわれた",[EN_NAME objectAtIndex:_enType]]];
            if (_key==KEY_SELECT) _init=S_COMMAND;
        }
    }
    
    //コマンド
    else if (_scene==S_COMMAND) {
        [self drawBattle:@"　　1.攻撃　　2.逃げる"];
        if (_key==KEY_1) _init=S_ATTACK0;
        if (_key==KEY_2) _init=S_ESCAPE0;
    }
    //攻撃0
    else if (_scene==S_ATTACK0) {
        [self drawBattle:@"勇者の攻撃"];
        if (_key==KEY_SELECT) _init=S_ATTACK1;
    } 
    //攻撃1
    else if (_scene==S_ATTACK1) {
        //フラッシュ
        if (_tick<10) {
            [self drawBattle:@"勇者の攻撃" visible:_tick%2==0];
        }
        //ダメージの表示
        else {
            [self drawBattle:[NSString stringWithFormat:
                @"%dダメージ与えた！",_damage]];
            if (_key==KEY_SELECT) {
                //体力の計算
                _enHP-=_damage;
                if (_enHP<=0) _enHP=0;
                
                //遷移
                _init=(_enHP==0)?S_WIN:S_DEFENCE0;
            }
        }
    } 
    //勝利
    else if (_scene==S_WIN) {
        [self drawBattle:[NSString stringWithFormat:
            @"%@を倒した",[EN_NAME objectAtIndex:_enType]]];
        if (_key==KEY_SELECT) {
            //経験値の計算
            _yuEXP+=EN_EXP[_enType];
            
            //遷移
            if (_yuLV<3 && YU_EXP[_yuLV+1]<=_yuEXP) {
                _yuLV++;
                _init=S_LEVELUP;
            } else if (_enType==1) {
                _init=S_ENDING;
            } else {
                _init=S_MAP;
            }
        }
    } 
    //レベルアップ
    else if (_scene==S_LEVELUP) {     
        [self drawBattle:@"レベルアップした"];
        if (_key==KEY_SELECT) {
            //遷移
            _init=(_enType==1)?S_ENDING:S_MAP;
        }
    } 
    //エンディング
    else if (_scene==S_ENDING) {
        [_g setColorR:0 g:0 b:0];
        [_g fillRectX:0 y:0 w:WIDTH h:HEIGHT];
        [_g setColorR:255 g:255 b:255];
        [_g setFont:[UIFont systemFontOfSize:32]];
        NSString* str=@"Fin.";
        [_g drawString:str x:(WIDTH-[_g stringWidth:str])/2 y:200];
        if (_key==KEY_SELECT) _init=S_START;
    }
    //防御0
    else if (_scene==S_DEFENCE0) {
        [self drawBattle:[NSString stringWithFormat:
            @"%@の攻撃",[EN_NAME objectAtIndex:_enType]]];
        if (_key==KEY_SELECT) _init=S_DEFENCE1;
    } 
    //防御1
    else if (_scene==S_DEFENCE1) {
        //フラッシュ
        if (_tick<10) {
            if (_tick%2==0) {
                [_g setColorR:255 g:255 b:255];
                [_g fillRectX:0 y:0 w:WIDTH h:HEIGHT];
            } else {
                [self drawBattle:[NSString stringWithFormat:
                    @"%@の攻撃",[EN_NAME objectAtIndex:_enType]]];
            }
        } 
        //ダメージの表示
        else {
            [self drawBattle:[NSString stringWithFormat:
                @"%dダメージ受けた！",_damage]];
            if (_key==KEY_SELECT) {
                //体力の計算
                _yuHP-=_damage;
                if (_yuHP<=0) _yuHP=0;
                
                //遷移
                _init=(_yuHP==0)?S_GAMEOVER:S_COMMAND;
            }
        }
    }
    //ゲームオーバー
    else if (_scene==S_GAMEOVER) {
        [self drawBattle:@"勇者は力尽きた"];
        if (_key==KEY_SELECT) _init=S_START;
    }
    //逃走0
    else if (_scene==S_ESCAPE0) {
        [self drawBattle:@"勇者は逃げ出した"];
        if (_key==KEY_SELECT) {
            _init=(_enType==1 || [self rand:100]<=10)?S_ESCAPE1:S_MAP;
        }
    } 
    //逃走1
    else if (_scene==S_ESCAPE1) {
        [self drawBattle:[NSString stringWithFormat:
            @"%@は回り込んだ",[EN_NAME objectAtIndex:_enType]]];
        if (_key==KEY_SELECT) _init=S_DEFENCE0;
    }
    //時間経過
    _key=-999;
    _tick++;
    if (_tick>999) _tick=100;
}

//定期処理
- (void)onTick:(NSTimer*)timer {
    [self setNeedsDisplay];
}

//タッチ開始イベントの処理
- (void)touchesBegan:(NSSet*)touches withEvent:(UIEvent*)event {
    NSArray* objects=[touches allObjects];
    CGPoint pos=[[objects objectAtIndex:0] locationInView:self]; 
    pos.x/=SCALE;
    pos.y/=SCALE;
    if (_scene==S_MAP) {
        if (abs(pos.x-WIDTH/2)>abs(pos.y-HEIGHT/2)) {
            _key=(pos.x-WIDTH/2<0)?KEY_LEFT:KEY_RIGHT;
        } else {
            _key=(pos.y-HEIGHT/2<0)?KEY_UP:KEY_DOWN;
        }
    } else if (_scene==S_COMMAND) {
        if (HEIGHT-90<pos.y && pos.y<HEIGHT-60) {
            _key=(pos.x<WIDTH/2)?KEY_1:KEY_2;
        }
    } else {
        _key=KEY_SELECT;
    }
}
@end